/*
 * Copyright (C) 2021 eichehome
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package server;

/**
 *
 * @author eichehome
 */
public class FifoPipe {
    
    public PipeElement firstElement;
    public PipeElement lastElement;
    
    public FifoPipe() {
        
    }
    
    public void queuElement(Element element) {
        PipeElement pipeElement = new PipeElement(element);
        try {
            lastElement.setNextElement(pipeElement);
            lastElement = pipeElement;
        } catch (NullPointerException ex) {
            firstElement = pipeElement;
            lastElement = pipeElement;
        }
    }
    
    public PipeElement getNextElement() {
        PipeElement result = null;
        if (firstElement == null) {
            return result;
        } else {
            if (firstElement == lastElement) {
                result = firstElement;
                firstElement = null;
                lastElement = null;
                return result;
            } else {
                result = firstElement;
                PipeElement next = firstElement.getNext();
                firstElement = next;
                return result;
                
            }
        }
    }
    
}
